package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CursoDAO;
import com.rjconsultores.ventaboletos.entidad.Curso;

@Repository("cursoDAO")
public class CursoHibernateDAO extends GenericHibernateDAO<Curso, Integer>
		implements CursoDAO {

	@Autowired
	public CursoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<Curso> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("nomcurso"));

		return c.list();
	}

	public List<Curso> buscar(String nomcurso){
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("nomcurso", nomcurso));
		c.addOrder(Order.asc("nomcurso"));

		return c.list();
	}
}
